module Test.Data.String.Search.Utils where

import Data.Bounded.Generic (genericTop, genericBottom)
import Data.Enum (class BoundedEnum, class Enum)
import Data.Enum.Generic (genericCardinality, genericToEnum, genericFromEnum, genericSucc, genericPred)
import Data.Eq.Generic (genericEq)
import Data.Generic.Rep (class Generic)
import Data.String (CodePoint)
import Prelude (class Bounded, class Eq, class Ord)
import Data.Ord.Generic (genericCompare)
import Test.QuickCheck.Arbitrary (class Arbitrary)
import Test.QuickCheck.Gen (enum)


newtype CodePointA = CodePointA CodePoint

derive instance Generic CodePointA _
instance Eq CodePointA where
  eq = genericEq
instance Ord CodePointA where
  compare = genericCompare
instance Bounded CodePointA where
  top = genericTop
  bottom = genericBottom
instance Enum CodePointA where
  succ = genericSucc
  pred = genericPred
instance BoundedEnum CodePointA where
  cardinality = genericCardinality
  toEnum = genericToEnum
  fromEnum = genericFromEnum
instance Arbitrary CodePointA where
  arbitrary = enum

